﻿# Elasticsearch cars

Small application about cars for practicing with elasticsearch-dsl library.


## Application structure
- elasticsearch_cars
    - brands
    - cars
    - elasticsearch_cars
    - examples
    - manufacturers
    - params
    - search


## Installing Elasticsearch v6.8

SEE: https://www.elastic.co/guide/en/elasticsearch/reference/6.8/install-elasticsearch.html

Also this plugin for chrome is recommended: https://chrome.google.com/webstore/detail/elasticsearch-head/ffmkiejjmecolpfloofpjologoblkegm

Or you can also use Kibana tool from elasticsearch: https://www.elastic.co/downloads/past-releases#kibana
(harder to work with but more features)


## Installing application

```
1] cd <your_project_path>/elasticsearch_dsl_practice
   virtualenv env
   source env/bin/activate (Windows: env\Scripts\activate.bat)

2] pip install -r requirements.txt

3] cd elasticsearch_cars 
   python manage.py runserver
```


## Usage

- database is ready with prepopulated data
- existing user for administration - `login: admin, pass: admin4321`

Use cases to work with can be found in the `examples` folder. Every file can
be ran as standalone script (thanks to top section of the file).
Django is ready at this point, so you can use full power of it.

You can also use included presentation to better understand theoretical concepts behind the examples.
(Examples in presentation are most of the time very similar to practical examples here)


## Troubleshooting
In case you will have any problems, please let me know at: `standa@whys.dev`