from django.db import models
from django.utils.translation import gettext_lazy as _

from parler.models import TranslatableModel, TranslatedFields
from manufacturers.models import Manufacturer


class Brand(models.Model):
    name = models.CharField(_("name"), max_length=128, default="")
    manufacturer = models.ForeignKey(
        Manufacturer, verbose_name=_("manufacturer"), related_name="brands", on_delete=models.CASCADE,
        null=True, blank=False
    )

    class Meta:
        verbose_name = _("brand")
        verbose_name_plural = _("brands")

    def __str__(self):
        return f"{self.name} ({self.manufacturer})"
