import os
import sys
import django

SETTINGS = 'elasticsearch_cars.settings'
sys.path.append(os.path.abspath(os.path.join(os.path.realpath(__file__), "..", "..")))
os.environ.setdefault("DJANGO_SETTINGS_MODULE", SETTINGS)
django.setup()

from search.analyzers import *
from elasticsearch_dsl import Index
from elasticsearch_dsl.connections import Elasticsearch
from search.documents import CarDocument

idx = Index("dev_portal_ege__products_variant_2021_03_18_21_31_29")
sentence = "<p>Koupil jsem si krásné nové auto.</p>"

# 1] standard analyzer

tokens = idx.analyze(body={"analyzer": "standard", "text": sentence})["tokens"]
print([token["token"] for token in tokens])

# 2] ascii fold

# tokens = Analyzers.ascii_fold.simulate(sentence).tokens
# print([token["token"] for token in tokens])


# 3] partial_word_analyzer

# tokens = Analyzers.partial_word_analyzer.simulate(sentence).tokens
# print([token["token"] for token in tokens])

# 4] partial_edge_word_analyzer

# tokens = Analyzers.partial_edge_word_analyzer.simulate(sentence).tokens
# print([token["token"] for token in tokens])
