import os
import sys
import django

SETTINGS = 'elasticsearch_cars.settings'
sys.path.append(os.path.abspath(os.path.join(os.path.realpath(__file__), "..", "..")))
os.environ.setdefault("DJANGO_SETTINGS_MODULE", SETTINGS)
django.setup()

from search.analyzers import *
from elasticsearch_dsl import Index, Search
from elasticsearch_dsl.query import Match, Q
from elasticsearch_dsl.connections import Elasticsearch, connections
from examples.utils import print_response, print_prepared_query
from search.documents import CarDocument


# Prepare query
q = Q("match", description__cs="Auto roku") & Q("match", brand_name="Mercedes")
#
# # 1] Match query with concatenation + response handling
#
# search = Search(index="elastic-cars").query(q)
#
# print(str(search.to_dict()).replace("'", '"'))
# print()
# response = search.execute()
# for hit in response.hits:
#     print(hit.to_dict())
#
# print(f"response.hits.total = {response.hits.total}")
# print(f"response.hits.max_score = {response.hits.max_score}")
# print(f"response.took = {response.took}")
# print(f"response.success = {response.success()}")

# 2]  Match query with with and concatenation
#     - with commented django_init()
#     - we must create connection and set client for searching

# client = connections.create_connection()
#
# search = Search(index="elastic-cars").using(client).query(q)
# response = search.execute()
# print_response(response)


# 3] Match query with with and concatenation
#    - via CarDocument class
#    - NOTE: we do not need to specify index or connection

# search = CarDocument.search().query(q)
# response = search.execute()
# print_response(response)


# 4] Match all cars with brand name "BMW" and price must be higher than 1500000,
#    also ordered by highest price
#    - NOTE: see [0:10] which restrict result for 10 documents
#    - NOTE: score will be null, because we are sorting by price
#            can be explicitly written as _score

# search = Search(index="elastic-cars") \
#         .query(
#             Q("match", brand_name="BMW") &
#             ~Q("range", price={"gte": 1500000})
#         ) \
#         .sort(
#             "-price",
#         )[0:10]
#
# print_prepared_query(search)
# response = search.execute()
# print_response(response)

