import os
import sys
import django

SETTINGS = 'elasticsearch_cars.settings'
sys.path.append(os.path.abspath(os.path.join(os.path.realpath(__file__), "..", "..")))
os.environ.setdefault("DJANGO_SETTINGS_MODULE", SETTINGS)
django.setup()

from datetime import datetime
from search.analyzers import *
from elasticsearch_dsl import Index, Search, Document
from elasticsearch_dsl.query import Q
from elasticsearch_dsl.connections import Elasticsearch
from examples.utils import print_response, print_prepared_query, pretty_json
from search.documents import CarDocument

timestamp = datetime.now().strftime('%Y_%m_%d_%H_%M_%S')
new_index_name = f"{CarDocument._index._name}_{timestamp}"


# class CarDocument(Document):
#
#     class Index:
#         name = "elastic-cars"
#         settings = {}
#         analyzers = {
#
#         }
#
#     @classmethod
#     def init(cls, index=None, using=None):
#         # adding timestamp to new index name
#         # register aliases
#         cls._index.aliases(**{"elastic-cars": {}})
#         # register analyzers
#         # cls._index.analyzer(Analyzers.ascii_fold)
#         # cls._index.analyzer(Analyzers.partial_word_analyzer)
#         # cls._index.analyzer(Analyzers.partial_edge_word_analyzer)
#
#         super().init(index=new_index_name, using=using)


# 1] create index with two aliases - normal and with filter (missing settings)
# index = Index(f"{CarDocument._index._name}_{timestamp}")
# index.aliases(**{"elastic-cars": {}})
# index.aliases(**{"elastic-cars-gt-2019": {"filter": Q("range", created_dt={"gt": "2019", "format": "yyyy"})}})
# index.document(document=CarDocument)
# index.create()

# 2] create index with alias - low level api (missing settings)
# es_client = CarDocument._get_connection()
# es_client.indices.create(index=new_index_name)
# es_client.indices.update_aliases(body={
#     'actions': [
#         {"add": {"alias": CarDocument._index._name, "index": new_index_name}},
#     ]
# })

# 3] create index with alias - init (missing aliases, settings, must be override)
# CarDocument.init()
#
#
# idx = CarDocument._index
# print(idx.get_alias())
# print(pretty_json(idx.get_settings()))