from elasticsearch_dsl import (
    InnerDoc, Keyword, Text
)
from search.analyzers import Analyzers


class ParamInnerDoc(InnerDoc):
    name = Keyword()
    value = Keyword()


class MultilangTextInnerDoc(InnerDoc):
    cs = Text(
        analyzer=Analyzers.partial_edge_word_analyzer,
        search_analyzer=Analyzers.ascii_fold,
        # multifield
        fields={'raw': Keyword()}
    )
    en = Text(
        analyzer=Analyzers.partial_edge_word_analyzer,
        # NOTE: see different analyzer here for different language
        search_analyzer="standard",
        # multifield
        fields={'raw': Keyword()}
    )


class MultilangKeywordInnerDoc(InnerDoc):
    cs = Keyword()
    en = Keyword()
